
local violationsSkinned = {}

function Skinner:Violation()

	if Violation.db.profile.showWindows then 
		self:skinViolation() 
	else
		self:SecureHook(Violation, "OpenWindows", function(this)
-- 			self:Debug("OpenWindows")
			self:skinViolation()
			end)
	end
	self:SecureHook(Violation, "SetupWindows", function(this)
-- 		self:Debug("SetupWindows")
		self:skinViolation()
		end)
	self:SecureHook(Violation, "UpdateWindows", function(this, sameamount)
-- 		self:Debug("UpdateWindows: [%s]", sameamount)
		self:skinViolation()
		end)
	self:SecureHook(Violation, "DeleteWindow", function(this, window)
-- 		self:Debug("DeleteWindow: [%s, %s]", window, window.frame)
		violationsSkinned[window.frame] = nil
		if self:IsHooked(frame, "OnShow") then self:Unhook(frame, "OnShow") end
		end)

end

function Skinner:skinViolation()

	for k, Vw in ipairs( Violation.windows ) do
-- 		self:Debug("V-window: [%s]", Vw)
		if Vw then
			local frame = Vw.frame
-- 			self:Debug("V-frame: [%s, %s, %s, %s]", frame, violationsSkinned[frame], Vw.options.show, frame:IsShown())
			if Vw.options.show then
				if not violationsSkinned[frame] then
					self:VframeSkin(frame)
					-- hook this to manage the frame
					if not self:IsHooked(frame, "OnShow") then
						self:HookScript(frame, "OnShow", function(this, ...) 
-- 							self:Debug("V-frame_OnShow: [%s, %s]", this, ... or "?")
							self.hooks[this].OnShow(this, ...)
							self:VframeSkin(this, true)
							end)
					end
					if not self:IsHooked(frame, "OnHide") then
						self:HookScript(frame, "OnHide", function(this, ...) 
-- 							self:Debug("V-frame_OnHide: [%s, %s]", this, ... or "?")
							self.hooks[this].OnHide(this, ...)
							violationsSkinned[this] = nil
							end)
					end
					-- hook these to stop the Backdrop colours from being changed 
-- 					self:Hook(frame, "SetBackdropColor", function(r, g, b, a) end, true)
					if not self:IsHooked(frame, "SetBackdropBorderColor") then
						self:Hook(frame, "SetBackdropBorderColor", function(r, g, b, a) end, true)
					end
					-- hook this to manage the statusbars
					if not self:IsHooked(Vw, "SetBar") then
						self:SecureHook(Vw, "SetBar", function(this, count, rank, name, value, percent, dataInfo)
							local btn = this.currentBars[count]
-- 							self:Debug("V-statusbar: [%s, %s]", btn, btn.statusbar)
							if btn then
-- 								self:Debug("V: [%s, %s]", btn, btn:GetWidth())
								btn:ClearAllPoints()						
								if count == 1 then
									btn:SetPoint( "TOP", this.frame, "TOP", 0, -21 )
								else
									btn:SetPoint( "TOP", this.currentBars[count - 1], "BOTTOM", 0, -1 )
								end
								btn:SetPoint( "LEFT", this.frame, "LEFT", 4, 0)
								btn:SetPoint( "RIGHT", this.frame, "RIGHT", -4, 0)
							end
							end)
					end
				end
			end
		end
	end
	
end

function Skinner:VframeSkin(frame, os)

-- 	self:Debug("VframeSkin: [%s, %s, %s]",frame, violationsSkinned[frame], os)
	
	if not violationsSkinned[frame] then
		frame.header:SetWidth(frame:GetWidth() - 48)
		local p, r2, rp, x, y = frame.header:GetPoint()
-- 		self:Debug("V_header_GP: [%s, %s, %s, %s, %s]", p, r2:GetName(), rp, x, y)
		if y ~= -5 then
			self:moveObject(frame.header, nil, nil, "+", 9, frame)
			self:moveObject(frame.closebutton, nil, nil, "+", 9, frame)
			self:moveObject(frame.prevbutton, nil, nil, "+", 9, frame)
			self:moveObject(frame.nextbutton, nil, nil, "+", 9, frame)
		end
		self:applySkin(frame)
		violationsSkinned[frame] = true
	end
	
end

